package io.swagger.api;

import io.swagger.model.*;
import io.swagger.api.AuthApiService;
import io.swagger.api.factories.AuthApiServiceFactory;

import io.swagger.annotations.ApiParam;


import java.util.List;
import io.swagger.api.NotFoundException;

import java.io.InputStream;

import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.glassfish.jersey.media.multipart.FormDataParam;

import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.*;

@Path("/auth")
@Consumes({ "application/json" })
@Produces({ "application/json" })
@io.swagger.annotations.Api(description = "the auth API")
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2016-11-03T11:50:38.179+04:00")
public class AuthApi  {
   private final AuthApiService delegate = AuthApiServiceFactory.getAuthApi();

    @POST
    @Path("/login")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Получить ключ доступа", notes = "Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр 'token'). Для вычисления значения параметра 'response' необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&nbsp;+&nbsp;salt&nbsp;+&nbsp;'\\n'))", response = String.class, tags={ "auth / Авторизация, начало работы с API", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Ключ доступа", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response authLoginPost(@ApiParam(value = "Имя пользователя",required=true) @QueryParam("login") String login
,@ApiParam(value = "Соль (см. /auth/start)",required=true) @QueryParam("salt") String salt
,@ApiParam(value = "Вычисленный хэш",required=true) @QueryParam("response") String response
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.authLoginPost(login,salt,response,securityContext);
    }
    @GET
    @Path("/start")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Получить соль", notes = "Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.", response = String.class, tags={ "auth / Авторизация, начало работы с API", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Соль для авторизации", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response authStartGet(@ApiParam(value = "Имя пользователя",required=true) @QueryParam("login") String login
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.authStartGet(login,securityContext);
    }
}
