package io.swagger.api;

import io.swagger.model.*;
import io.swagger.api.BillingApiService;
import io.swagger.api.factories.BillingApiServiceFactory;

import io.swagger.annotations.ApiParam;

import io.swagger.model.InlineResponse200;
import io.swagger.model.InlineResponse2001;
import io.swagger.model._;

import java.util.List;
import io.swagger.api.NotFoundException;

import java.io.InputStream;

import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.glassfish.jersey.media.multipart.FormDataParam;

import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.*;

@Path("/billing")
@Consumes({ "application/json" })
@Produces({ "application/json" })
@io.swagger.annotations.Api(description = "the billing API")
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2016-11-03T11:50:38.179+04:00")
public class BillingApi  {
   private final BillingApiService delegate = BillingApiServiceFactory.getBillingApi();

    @GET
    @Path("/debt")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Информация по дебету аккаунта", notes = "Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения", response = InlineResponse200.class, responseContainer = "List", tags={ "Аккаунт - биллинг, свойства и статус", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Информация по дебету аккаунта", response = InlineResponse200.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse200.class, responseContainer = "List") })
    public Response billingDebtGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.billingDebtGet(token_,securityContext);
    }
    @GET
    @Path("/info")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Информация об аккаунте", notes = "Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.", response = InlineResponse2001.class, responseContainer = "List", tags={ "Аккаунт - биллинг, свойства и статус", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Информация об аккаунте", response = InlineResponse2001.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2001.class, responseContainer = "List") })
    public Response billingInfoGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.billingInfoGet(token_,securityContext);
    }
    @GET
    @Path("/limits")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Получить ограничения аккаунта", notes = "", response = _.class, tags={ "Аккаунт - биллинг, свойства и статус", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Ограничения аккаунта", response = _.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = _.class) })
    public Response billingLimitsGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.billingLimitsGet(token_,securityContext);
    }
}
