package io.swagger.api;

import io.swagger.model.*;
import io.swagger.api.DnsApiService;
import io.swagger.api.factories.DnsApiServiceFactory;

import io.swagger.annotations.ApiParam;

import io.swagger.model.InlineResponse2003;
import io.swagger.model.InlineResponse2004;

import java.util.List;
import io.swagger.api.NotFoundException;

import java.io.InputStream;

import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.glassfish.jersey.media.multipart.FormDataParam;

import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.*;

@Path("/dns")
@Consumes({ "application/json" })
@Produces({ "application/json" })
@io.swagger.annotations.Api(description = "the dns API")
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2016-11-03T11:50:38.179+04:00")
public class DnsApi  {
   private final DnsApiService delegate = DnsApiServiceFactory.getDnsApi();

    @GET
    @Path("/add")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Создание записи домена", notes = "", response = String.class, tags={ "DNS - доменные имена, привязки", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response dnsAddGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "зона, которую необходимо создать",required=true) @QueryParam("add_dns_zone") String addDnsZone
,@ApiParam(value = "") @QueryParam("add_dns_record") String addDnsRecord
,@ApiParam(value = "ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку") @QueryParam("iis_site_for_dns") String iisSiteForDns
,@ApiParam(value = "") @QueryParam("bind_only") Boolean bindOnly
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.dnsAddGet(token_,addDnsZone,addDnsRecord,iisSiteForDns,bindOnly,securityContext);
    }
    @GET
    @Path("/bind")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Привязка одного домена к другому", notes = "", response = String.class, tags={ "DNS - доменные имена, привязки", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response dnsBindGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID домена из списка /dns/list",required=true) @QueryParam("_key_") Integer key_
,@ApiParam(value = "домен, к которому необходимо сделать привязку") @QueryParam("bind_to") String bindTo
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.dnsBindGet(token_,key_,bindTo,securityContext);
    }
    @GET
    @Path("/list")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Получить список доменных имён", notes = "", response = InlineResponse2003.class, responseContainer = "List", tags={ "DNS - доменные имена, привязки", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Список доменных имён", response = InlineResponse2003.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2003.class, responseContainer = "List") })
    public Response dnsListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.dnsListGet(token_,securityContext);
    }
    @GET
    @Path("/prolong/list")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Информация по продлению доменов", notes = "", response = InlineResponse2004.class, responseContainer = "List", tags={ "DNS - доменные имена, привязки","Аккаунт - биллинг, свойства и статус", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Информация по продлению доменов", response = InlineResponse2004.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2004.class, responseContainer = "List") })
    public Response dnsProlongListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.dnsProlongListGet(token_,securityContext);
    }
    @GET
    @Path("/raw")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Редактирование \"сырой\" зоны", notes = "", response = String.class, tags={ "DNS - доменные имена, привязки", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response dnsRawGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID домена из /dns/list",required=true) @QueryParam("_key_") Integer key_
,@ApiParam(value = "Значение '1' сообщает, что запись необходимо удалить",required=true) @QueryParam("s_del") Integer sDel
,@ApiParam(value = "Значение '1' сообщает, что запись необходимо создать",required=true) @QueryParam("s_add") Integer sAdd
,@ApiParam(value = "Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV",required=true) @QueryParam("dns_type") String dnsType
,@ApiParam(value = "Имя записи, либо '@' для корневой",required=true) @QueryParam("dns_name") String dnsName
,@ApiParam(value = "Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)",required=true) @QueryParam("dns_value") String dnsValue
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.dnsRawGet(token_,key_,sDel,sAdd,dnsType,dnsName,dnsValue,securityContext);
    }
    @GET
    @Path("/raw/managedmx")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Редактировать DNS-зону", notes = "", response = String.class, tags={ "DNS - доменные имена, привязки", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response dnsRawManagedmxGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID домена из /dns/list",required=true) @QueryParam("_key_") Integer key_
,@ApiParam(value = "Значение '1', если необходимо включить поддержку на MX-серверах хостинга и '0', если выключить",required=true) @QueryParam("managed_mx") Integer managedMx
,@ApiParam(value = "Значение '1' подтверждает операцию",required=true) @QueryParam("upd_managed_mx") Integer updManagedMx
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.dnsRawManagedmxGet(token_,key_,managedMx,updManagedMx,securityContext);
    }
}
