package io.swagger.api;

import io.swagger.model.*;
import io.swagger.api.EmailApiService;
import io.swagger.api.factories.EmailApiServiceFactory;

import io.swagger.annotations.ApiParam;

import io.swagger.model.InlineResponse2005;
import io.swagger.model.InlineResponse2006;

import java.util.List;
import io.swagger.api.NotFoundException;

import java.io.InputStream;

import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.glassfish.jersey.media.multipart.FormDataParam;

import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.*;

@Path("/email")
@Consumes({ "application/json" })
@Produces({ "application/json" })
@io.swagger.annotations.Api(description = "the email API")
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2016-11-03T11:50:38.179+04:00")
public class EmailApi  {
   private final EmailApiService delegate = EmailApiServiceFactory.getEmailApi();

    @GET
    @Path("/add")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Создание почтового ящика", notes = "", response = String.class, tags={ "Электронная почта - почтовые ящики", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response emailAddGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "Адрес почтового ящика, который необходимо создать",required=true) @QueryParam("add_email") String addEmail
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.emailAddGet(token_,addEmail,securityContext);
    }
    @GET
    @Path("/alias/delete")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Удаление псевдонимов почтовых ящиков", notes = "", response = String.class, tags={ "Электронная почта - почтовые ящики", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response emailAliasDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "Адрес почтового ящика, подлежащего удалению",required=true) @QueryParam("_key_") String key_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.emailAliasDeleteGet(token_,key_,securityContext);
    }
    @GET
    @Path("/alias/list")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Получить список псевдонимов почтовых ящиков", notes = "", response = InlineResponse2005.class, responseContainer = "List", tags={ "Электронная почта - почтовые ящики", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Список псевдонимов почтовых ящиков", response = InlineResponse2005.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2005.class, responseContainer = "List") })
    public Response emailAliasListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.emailAliasListGet(token_,securityContext);
    }
    @GET
    @Path("/delete")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Удаление почтового ящика", notes = "", response = String.class, tags={ "Электронная почта - почтовые ящики", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response emailDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "Адрес почтового ящика, подлежащего удалению",required=true) @QueryParam("_key_") String key_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.emailDeleteGet(token_,key_,securityContext);
    }
    @GET
    @Path("/list")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Получить список почтовых ящиков", notes = "", response = InlineResponse2006.class, responseContainer = "List", tags={ "Электронная почта - почтовые ящики", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Список почтовых ящиков", response = InlineResponse2006.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2006.class, responseContainer = "List") })
    public Response emailListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.emailListGet(token_,securityContext);
    }
}
