package io.swagger.api;

import io.swagger.model.*;
import io.swagger.api.VdsApiService;
import io.swagger.api.factories.VdsApiServiceFactory;

import io.swagger.annotations.ApiParam;

import io.swagger.model.InlineResponse20011;
import io.swagger.model.InlineResponse20012;
import io.swagger.model.InlineResponse20013;

import java.util.List;
import io.swagger.api.NotFoundException;

import java.io.InputStream;

import org.glassfish.jersey.media.multipart.FormDataContentDisposition;
import org.glassfish.jersey.media.multipart.FormDataParam;

import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.*;

@Path("/vds")
@Consumes({ "application/json" })
@Produces({ "application/json" })
@io.swagger.annotations.Api(description = "the vds API")
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2016-11-03T11:50:38.179+04:00")
public class VdsApi  {
   private final VdsApiService delegate = VdsApiServiceFactory.getVdsApi();

    @GET
    @Path("/create")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Изменение параметров VDS", notes = "Изменение параметров уже существующего VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "ID VDS", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response vdsCreateGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "Тип создаваемого VDS. 'vz1', 'vz2', 'vz3', 'vz4', 'vz5' или 'vds.dynamic'. По умолчанию 'vds.dynamic'") @QueryParam("type") String type
,@ApiParam(value = "Количество доступной памяти в мегабайтах. По умолчанию 2048") @QueryParam("cr_hvmem") Integer crHvmem
,@ApiParam(value = "Количество доступных гигабайт диска. По умолчанию 30") @QueryParam("cr_hvdsk") Integer crHvdsk
,@ApiParam(value = "Количество ядер CPU. По умолчанию 2") @QueryParam("cr_hvcpu") Integer crHvcpu
,@ApiParam(value = "Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list") @QueryParam("template") String template
,@ApiParam(value = "") @QueryParam("force_memo") String forceMemo
,@ApiParam(value = "") @QueryParam("hv_1gb_panel_version") String hv1gbPanelVersion
,@ApiParam(value = "Необходимо ли установить панель 1Gb на VDS") @QueryParam("panel_install") Boolean panelInstall
,@ApiParam(value = "Создать всю систему на SSD") @QueryParam("cr_ssd1") Boolean crSsd1
,@ApiParam(value = "Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)") @QueryParam("cr_hv_all_system") Boolean crHvAllSystem
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsCreateGet(token_,type,crHvmem,crHvdsk,crHvcpu,template,forceMemo,hv1gbPanelVersion,panelInstall,crSsd1,crHvAllSystem,securityContext);
    }
    @GET
    @Path("/delete")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Удаление VDS", notes = "Предоставляет функционал для удаления VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response vdsDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list",required=true) @QueryParam("_key_") Integer key_
,@ApiParam(value = "Если true, VDS будет удален срочно") @QueryParam("force_critical") Boolean forceCritical
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsDeleteGet(token_,key_,forceCritical,securityContext);
    }
    @GET
    @Path("/ip/add")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Добавление IP на VDS", notes = "Этот вызов позволяет добавить ещё один IP адрес на указанный VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "IP-адрес успешно добавлен", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response vdsIpAddGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list",required=true) @QueryParam("_key_") Integer key_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsIpAddGet(token_,key_,securityContext);
    }
    @GET
    @Path("/ip/delete")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Удаление IP с VDS", notes = "Этот вызов позволяет отвязать IP адрес от VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "IP-адрес успешно удалён", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response vdsIpDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list",required=true) @QueryParam("_key_") Integer key_
,@ApiParam(value = "IP адрес, который необходимо удалить",required=true) @QueryParam("del_ip") String delIp
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsIpDeleteGet(token_,key_,delIp,securityContext);
    }
    @GET
    @Path("/ip/list")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Список IP-адресов виртуальных серверов", notes = "Список IP-адресов виртуальных серверов", response = InlineResponse20011.class, responseContainer = "List", tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Список IP-адресов виртуальных серверов", response = InlineResponse20011.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse20011.class, responseContainer = "List") })
    public Response vdsIpListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list") @QueryParam("_key_") Integer key_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsIpListGet(token_,key_,securityContext);
    }
    @GET
    @Path("/list")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Список виртуальных серверов", notes = "Позволяет получить список виртуальных серверов", response = InlineResponse20012.class, responseContainer = "List", tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Список виртуальных серверов", response = InlineResponse20012.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse20012.class, responseContainer = "List") })
    public Response vdsListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS") @QueryParam("_key_") Integer key_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsListGet(token_,key_,securityContext);
    }
    @GET
    @Path("/reboot")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Перезагрузка VDS", notes = "Предоставляет функционал для перезагрузки VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response vdsRebootGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list",required=true) @QueryParam("_key_") Integer key_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsRebootGet(token_,key_,securityContext);
    }
    @GET
    @Path("/templates-list")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Список шаблонов виртуальных серверов", notes = "Позволяет получить список шаблонов виртуальных серверов", response = InlineResponse20013.class, responseContainer = "List", tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Список шаблонов виртуальных серверов", response = InlineResponse20013.class, responseContainer = "List"),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse20013.class, responseContainer = "List") })
    public Response vdsTemplatesListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsTemplatesListGet(token_,securityContext);
    }
    @GET
    @Path("/update")
    @Consumes({ "application/json" })
    @Produces({ "application/json" })
    @io.swagger.annotations.ApiOperation(value = "Создание VDS", notes = "Создание новых VDS с произвольными характеристиками", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @io.swagger.annotations.ApiResponses(value = { 
        @io.swagger.annotations.ApiResponse(code = 200, message = "Параметры VDS успешно обновлены", response = String.class),
        
        @io.swagger.annotations.ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    public Response vdsUpdateGet(@ApiParam(value = "Ключ доступа, полученный при авторизации",required=true) @QueryParam("_token_") String token_
,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list",required=true) @QueryParam("_key_") Integer key_
,@ApiParam(value = "Количество доступной памяти в мегабайтах. По умолчанию 2048") @QueryParam("cr_hvmem") Integer crHvmem
,@ApiParam(value = "Количество доступных гигабайт диска. По умолчанию 30") @QueryParam("cr_hvdsk") Integer crHvdsk
,@ApiParam(value = "Количество ядер CPU. По умолчанию 2") @QueryParam("cr_hvcpu") Integer crHvcpu
,@Context SecurityContext securityContext)
    throws NotFoundException {
        return delegate.vdsUpdateGet(token_,key_,crHvmem,crHvdsk,crHvcpu,securityContext);
    }
}
